// DlgInitGBA.cpp : t@C
//

#include "stdafx.h"
#include "FlashManager.h"
#include "DlgInitGBA.h"
#include "FlashManagerDlg.h"


// CDlgInitGBA _CAO

IMPLEMENT_DYNAMIC(CDlgInitGBA, CDialog)
CDlgInitGBA::CDlgInitGBA(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgInitGBA::IDD, pParent)
	, m_pThread(NULL)
{
}

CDlgInitGBA::~CDlgInitGBA()
{
}

void CDlgInitGBA::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDlgInitGBA, CDialog)
	ON_MESSAGE(WM_THREADFINISHED, OnThreadFinished)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CDlgInitGBA bZ[W nh

BOOL CDlgInitGBA::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO :  ɏǉĂ
	m_bAbort = FALSE;
	CFlashManagerDlg::m_bAbort = FALSE;
	m_pThread = AfxBeginThread(CDlgInitGBA::InitGBAProc, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

LRESULT CDlgInitGBA::OnThreadFinished(WPARAM wParam, LPARAM lParam)
{
	if ( m_bAbort ) OnCancel();
	else OnOK();

	return 0;
}

void CDlgInitGBA::PortChange()
{
	switch ( CFlashManagerDlg::m_base )
	{
	case 0x0278 :
		CFlashManagerDlg::m_base = 0x0378;
		break;
	case 0x0378 :
		CFlashManagerDlg::m_base = 0x03BC;
		break;
	default:
		CFlashManagerDlg::m_base = 0x0278;
	}
}

volatile BOOL CDlgInitGBA::m_bAbort = FALSE;
const u8 CFlashManagerDlg::m_fwlib[] =
// #include "fwlib.h"
#include "agb_prog.h"
;

UINT CDlgInitGBA::InitGBAProc(LPVOID pParam)
{
	// p|[g
#ifndef LANG_ENG
	::SetDlgItemText((HWND) pParam, IDC_STATIC1, _T("GBA ƐڑłB"));
#else
	::SetDlgItemText((HWND) pParam, IDC_STATIC1, _T("Connecting GBA..."));
#endif
	s32 i;
	HANDLE h;
	h = ::CreateFile(_T("\\\\.\\giveio"), GENERIC_READ, 0, NULL,
					OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if( h != INVALID_HANDLE_VALUE )
		::CloseHandle(h);
	CFlashManagerDlg::m_base = 0x378;
	while ( TRUE ) {
		if ( m_bAbort ) goto THREADFINISH;
		outport(CFlashManagerDlg::m_base + 2, DIR_OFF | PCSTB_OFF);
		outport(CFlashManagerDlg::m_base + 0, 0x05);
		for ( i = 0; i < 100; i++ ) {
			if ( ((inport(CFlashManagerDlg::m_base + 1) >> 3) & 0x0f) == 0x05 ) break;
		}
		if( i == 100 ) {
			PortChange();
			continue;
		}
		outport(CFlashManagerDlg::m_base + 0, 0x0a);
		for ( i = 0; i < 100; i++ ) {
			if ( ((inport(CFlashManagerDlg::m_base + 1) >> 3) & 0x0f) == 0x0a ) break;
		}
		if ( i == 100 ) {
			PortChange();
			continue;
		}
		outport(CFlashManagerDlg::m_base + 0, 0x05);
		for ( i = 0; i < 100; i++ ) {
			if ( ((inport(CFlashManagerDlg::m_base + 1) >> 3) & 0x0f) == 0x05 ) break;
		}
		if ( i == 100 ) {
			PortChange();
			continue;
		}
		break;
	}

	// fwlib 
#ifndef LANG_ENG
	::SetDlgItemText((HWND) pParam, IDC_STATIC1, _T("GBA  fwlib ]łB"));
#else
	::SetDlgItemText((HWND) pParam, IDC_STATIC1, _T("Fowording fwlib to GBA..."));
#endif
	while ( TRUE )
	{
		if ( m_bAbort ) goto THREADFINISH;
		if ( CFlashManagerDlg::Read32bit() == 0x5555AAAA ) break;
	}
	for ( i = 0; i < 16; i++ )
	{
		CFlashManagerDlg::Write32bit(0xFFFFFFFF);
	}
	CFlashManagerDlg::Write32bit(0);
	CFlashManagerDlg::Write32bit(sizeof(CFlashManagerDlg::m_fwlib));
	u32 *ptr = (u32*)CFlashManagerDlg::m_fwlib;
	for ( i = 0; i < (sizeof(CFlashManagerDlg::m_fwlib) + 3) / 4; i++ )
	{
		CFlashManagerDlg::Write32bit(*ptr++);
	}
	Sleep(100);					//wait GBA is up
#ifndef LANG_ENG
	::SetDlgItemText((HWND) pParam, IDC_STATIC1, _T("JZbg͒łB"));
#else
	::SetDlgItemText((HWND) pParam, IDC_STATIC1, _T("Analyzing the cartridge..."));
#endif
	CFlashManagerDlg::GetCartInfo();

THREADFINISH:
	::PostMessage((HWND) pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

void CDlgInitGBA::OnBnClickedCancel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	m_bAbort = TRUE;
	CFlashManagerDlg::m_bAbort = TRUE;
//	OnCancel();
}
