// FlashManager.h : PROJECT_NAME AvP[ṼC wb_[ t@CłB
//

#pragma once

#define FWLIB_BEGIN	0x0000A1D4
#define FWLIB_END	0x0000CE03
#define FWLIB_LEN	(FWLIB_END - FWLIB_BEGIN + 1)
#define	FWLIB_NAME	"devman.exe"
#define FWLIB_CRC	0xA046485B

#define WM_THREADFINISHED	WM_USER + 5	// [U[`bZ[W

#define ROM_BASE_ADR	0x08000000
#define CART_LOGO_OFST	0x00000004
#define CART_NAME_OFST	0x000000A0
#define GAME_CODE_OFST	0x000000AC
#define BLOCK_SIZE		0x00008000
#define MAX_MULTI_GAMES	100
#define MAX_CART_LOGO	156
#define MAX_CART_NAME	12
#define MAX_GAME_CODE	4

#define FW_ACK					0x12345678
#define CMD_ROM_PROBE			0xffff0001 //
#define CMD_WRAM_LOADEXEC		0xffff0002 //len
#define CMD_ROM_BERASE			0xffff0003 //add
#define CMD_ROM_WRITE			0xffff0004 //add,len
#define CMD_ROM_BWRITE			0xffff0005 //add,len whith erase
#define CMD_READ				0xffff0006 //add,len
#define CMD_WRITE				0xffff0007 //add,len
#define CMD_FIND				0xffff0008 //add,len,strlen+(inc << 16)
#define CMD_BOOT_ROM			0xffff0009 //
#define CMD_SRAM2EWRAM			0xffff000a //bank    ERAM:0x02010000
#define CMD_EWRAM2SRAM			0xffff000b //bank    ERAM:0x02010000
#define CMD_BU_PROBE			0xffff000c //
#define CMD_SRAM_READ			0xffff000d //ofs,len
#define CMD_EEP_READ			0xffff000e //ofs,len
#define CMD_EEP_WRITE			0xffff000f //ofs,len
#define CMD_SRAM_WRITE			0xffff0010 //ofs,len
#define CMD_FLASH_WRITE			0xffff0011 //ofs,len
#define CMD_BLANK				0xffff0020 //
#define CMD_IS_PRO				0xffff0021 //32KbytePʂPGMzuł邩H


//base+1(input)
#define	_GBSTB		0x80
	
//base+2(output)
#define	PCSTB_ON	0x00
#define	PCSTB_OFF	0x01
#define	DIR_ON		0x04
#define	DIR_OFF		0x00

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// C V{

#include "pio.h"
#include "type.h"
extern "C" void crc32_init(void);
extern "C" u32 crc32_calc(u8 *buf, u32 len);
extern "C" u32 crc32;


// CFlashManagerApp:
// ̃NX̎ɂẮAFlashManager.cpp QƂĂB
//

class CFlashManagerApp : public CWinApp
{
public:
	CFlashManagerApp();

// I[o[Ch
	public:
	virtual BOOL InitInstance();

// 

	DECLARE_MESSAGE_MAP()
};

extern CFlashManagerApp theApp;
