// FlashManagerDlg.h : wb_[ t@C
//

#pragma once
#include "afxcmn.h"


// CFlashManagerDlg _CAO
class CFlashManagerDlg : public CDialog
{
// RXgNV
public:
	CFlashManagerDlg(CWnd* pParent = NULL);	// WRXgN^

	static void Write4bit(u8 m);
	static void Write32bit(u32 m);
	static u8 Read4bit();
	static u32 Read32bit();
	static void GetCartInfo();
	static const u8 m_fwlib[];
	static u16 m_base;
	static volatile BOOL m_bAbort;
	static volatile BOOL m_bStop;
// _CAO f[^
	enum { IDD = IDD_FLASHMANAGER_DIALOG };
	CListCtrl m_list_rom_ctrl;
	int m_nRamBank64;
	int m_nRamBank32;
	int m_nRamBank8;
	int m_nRamSizeNo;
	CString m_strOffset;
	BOOL m_bEEPRom;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnThreadFinished(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBnClickedBtnStop();
	afx_msg void OnBnClickedBtnAread();
	afx_msg void OnBnClickedBtnErase();
	afx_msg void OnBnClickedBtnPwrite();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedBtnAwrite();
	afx_msg void OnBnClickedRdoB64a();
	afx_msg void OnBnClickedRdoS8();
	afx_msg void OnBnClickedBtnSread();
	afx_msg void OnBnClickedBtnSwrite();
	DECLARE_MESSAGE_MAP()
private:
	CString GetStrSize(u32 m);
	void BtnEnable(BOOL bEnable = TRUE);
	void RefreshCartInfo();
	void SetSramType();
	static void GetCartInfoA(HWND hWnd);
	static BOOL CRCCheck(u32 crc);
	static void ReadCart(u32 *buf, u32 offset, u32 len, BOOL bSram);
	static void WriteCart(u32 *buf, u32 offset, u32 len, BOOL bSram, BOOL bAppend);
	static UINT ReadRom(LPVOID pParam);
	static UINT EraseRom(LPVOID pParam);
	static UINT WritePreBoot(LPVOID pParam);
	static UINT WriteAppendRom(LPVOID pParam);
	static UINT ReadRam(LPVOID pParam);
	static UINT WriteRam(LPVOID pParam);
	static void SramToEEPRom(u32 len);
	static void EEPRomToSram(u32 len);
	CWinThread* m_pThread;
	UINT_PTR m_nTimer;
	CToolTipCtrl m_toolTipCtrl;
	static int m_nRomType;
	static int m_nRamType;
	static u32 m_nRomSize;
	static u32 m_nRomBlkSize;
	static u32 m_nRomUnuSize;
	static u32 m_nRamOffset;
	static u32 m_nRamSize;
	static BOOL m_bConvEEPRom;
	static CString m_strFileName;
	static TCHAR m_szCartName[MAX_MULTI_GAMES][MAX_CART_NAME + 1];
	static TCHAR m_szGameCode[MAX_MULTI_GAMES][MAX_GAME_CODE + 1];
	static u32 m_nStartAdr[MAX_MULTI_GAMES];
	static u32 m_nEndAdr[MAX_MULTI_GAMES];
	static const UINT m_iToolTipItems[];
	static const TCHAR m_szPrgFilter[];
	static const TCHAR m_szSavFilter[];
	static u8 m_buf[];
	static int m_nProgress;
};
