#include	"type.h"

u32 crc32_tbl[256];
u32 crc32;

void crc32_init(){
	u32 i,j,value;
	for(i = 0; i < 256; i++){
		value = i;
		for(j = 0; j < 8; j++){
			value = (value & 1) ? ((value >> 1) ^ 0xEDB88320) : (value >> 1 );
		}
		crc32_tbl[i] = value;
	}
	crc32 = 0xFFFFFFFF;
}

u32 crc32_calc(u8 *buf,u32 len){
	u32 cnt;
	for(cnt = 0; cnt < len; cnt++){
		crc32 = crc32_tbl[(u8)crc32 ^ buf[cnt]] ^ (crc32 >> 8);
	}
	return(~crc32);

}