// FlashManagerDlg.cpp : t@C
//

#include "stdafx.h"
#include "FlashManager.h"
#include "FlashManagerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// c[qg\_CAOEACe ID Q
const UINT CFlashManagerDlg::m_iToolTipItems[] = {
	IDOK,
	IDCANCEL,
	IDC_LIST_ROM,
	IDC_BTN_PWRITE,
	IDC_BTN_AWRITE,
	IDC_BTN_AREAD,
	IDC_BTN_ERASE,
	IDC_RDO_B64A,
	IDC_RDO_B64B,
	IDC_RDO_B64C,
	IDC_RDO_B64D,
	IDC_RDO_B32A,
	IDC_RDO_B32B,
	IDC_RDO_B8A,
	IDC_RDO_B8B,
	IDC_RDO_B8C,
	IDC_RDO_B8D,
	IDC_RDO_S8,
	IDC_RDO_S32,
	IDC_RDO_S64,
	IDC_RDO_S128,
	IDC_RDO_S256,
	IDC_EDT_SOFS,
	IDC_BTN_SWRITE,
	IDC_BTN_SREAD,
	IDC_CHK_EEPROM,
	IDC_PROGRESS1,
	IDC_BTN_STOP,
	0 };
u16	CFlashManagerDlg::m_base = 0;
int CFlashManagerDlg::m_nRomType = 0;
int CFlashManagerDlg::m_nRamType = 0;
u32 CFlashManagerDlg::m_nRomSize = 0;
u32 CFlashManagerDlg::m_nRomBlkSize = 0;
u32 CFlashManagerDlg::m_nRomUnuSize = 0;
u32 CFlashManagerDlg::m_nRamOffset = 0;
u32 CFlashManagerDlg::m_nRamSize = 0;
BOOL CFlashManagerDlg::m_bConvEEPRom = FALSE;
volatile
BOOL CFlashManagerDlg::m_bAbort = FALSE;
volatile
BOOL CFlashManagerDlg::m_bStop = FALSE;
CString CFlashManagerDlg::m_strFileName = _T("");
TCHAR CFlashManagerDlg::m_szCartName[MAX_MULTI_GAMES][MAX_CART_NAME + 1];
TCHAR CFlashManagerDlg::m_szGameCode[MAX_MULTI_GAMES][MAX_GAME_CODE + 1];
u32 CFlashManagerDlg::m_nStartAdr[MAX_MULTI_GAMES];
u32 CFlashManagerDlg::m_nEndAdr[MAX_MULTI_GAMES];
u8 CFlashManagerDlg::m_buf[BLOCK_SIZE];
int CFlashManagerDlg::m_nProgress = 0;
// CFlashManagerDlg _CAO



CFlashManagerDlg::CFlashManagerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFlashManagerDlg::IDD, pParent)
	, m_pThread(NULL)
	, m_nTimer(0)
	, m_nRamBank64(0)
	, m_nRamBank32(0)
	, m_nRamBank8(0)
	, m_nRamSizeNo(0)
	, m_strOffset(_T(""))
	, m_bEEPRom(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFlashManagerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_ROM, m_list_rom_ctrl);
	DDX_Radio(pDX, IDC_RDO_B64A, m_nRamBank64);
	DDX_Radio(pDX, IDC_RDO_B32A, m_nRamBank32);
	DDX_Radio(pDX, IDC_RDO_B8A, m_nRamBank8);
	DDX_Radio(pDX, IDC_RDO_S8, m_nRamSizeNo);
	DDX_Text(pDX, IDC_EDT_SOFS, m_strOffset);
	DDX_Check(pDX, IDC_CHK_EEPROM, m_bEEPRom);
}

BEGIN_MESSAGE_MAP(CFlashManagerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_THREADFINISHED, OnThreadFinished)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_STOP, OnBnClickedBtnStop)
	ON_BN_CLICKED(IDC_BTN_AREAD, OnBnClickedBtnAread)
	ON_BN_CLICKED(IDC_BTN_ERASE, OnBnClickedBtnErase)
	ON_BN_CLICKED(IDC_BTN_PWRITE, OnBnClickedBtnPwrite)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BTN_AWRITE, OnBnClickedBtnAwrite)
	ON_BN_CLICKED(IDC_RDO_B64A, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B64B, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B64C, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B64D, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B32A, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B32B, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B8A, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B8B, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B8C, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_B8D, OnBnClickedRdoB64a)
	ON_BN_CLICKED(IDC_RDO_S8, OnBnClickedRdoS8)
	ON_BN_CLICKED(IDC_RDO_S32, OnBnClickedRdoS8)
	ON_BN_CLICKED(IDC_RDO_S64, OnBnClickedRdoS8)
	ON_BN_CLICKED(IDC_RDO_S128, OnBnClickedRdoS8)
	ON_BN_CLICKED(IDC_RDO_S256, OnBnClickedRdoS8)
	ON_BN_CLICKED(IDC_CHK_EEPROM, OnBnClickedRdoS8)
	ON_BN_CLICKED(IDC_BTN_SREAD, OnBnClickedBtnSread)
	ON_BN_CLICKED(IDC_BTN_SWRITE, OnBnClickedBtnSwrite)
END_MESSAGE_MAP()


// CFlashManagerDlg bZ[W nh

BOOL CFlashManagerDlg::OnInitDialog()
{
	m_nRamBank64 = 0;
	m_nRamBank32 = 0;
	m_nRamBank8 = 0;
	m_nRamSizeNo = 2;
	m_bEEPRom = FALSE;
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	m_bAbort = FALSE;
	m_bStop = FALSE;
	CString msg;
	msg = ' ';
	msg += GetStrSize(m_nRomSize);
	switch ( m_nRomType )
	{
	case 0 :
		msg = _T("NONE");
		break;
	case 1 :
		msg.Insert(0, _T("MASK"));
		break;
	default :
		msg.Insert(0, _T("FLASH"));
	}
	SetDlgItemText(IDC_STC_ROMTYPE, msg);
	switch ( m_nRamType )
	{
	case 1 :
		msg = _T("SRAM 256Kbit");
		break;
	case 2 :
		msg = _T("SRAM 512Kbit");
		break;
	case 3 :
		msg = _T("FLASH 512Kbit");
		break;
	case 4 :
		msg = _T("EEPROM 4Kbit");
		break;
	case 5 :
		msg = _T("EEPROM 64Kbit");
		break;
	default :
		msg = _T("NONE");
	}
	SetDlgItemText(IDC_STC_RAMTYPE, msg);
#ifndef LANG_ENG
	TCHAR title[][20] = { _T("Q["), _T("R[h"), _T("ROM TCY") };
#else
	TCHAR title[][20] = { _T("Name of Game"), _T("Code"), _T("ROM Size") };
#endif
	int width[] = { 100, 50, 80 };
	int fmt[] = { 0, 0, LVCFMT_RIGHT };
	LV_COLUMN listcol;
	listcol.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;
	for ( int i = 0; i < sizeof(title) / sizeof(title[0]); i++ ) {
		listcol.pszText = title[i];
		listcol.cx = width[i];
		listcol.fmt = fmt[i];
		m_list_rom_ctrl.InsertColumn(i, &listcol);
	}
	RefreshCartInfo();
	OnBnClickedRdoS8();
	BtnEnable();
	// c[qgRg[쐬܂
	m_toolTipCtrl.Create( this );
	for ( int i = 0; m_iToolTipItems[i] != 0; i++ )
	{
		msg.LoadString(m_iToolTipItems[i]);
		m_toolTipCtrl.AddTool(GetDlgItem(m_iToolTipItems[i]), msg);
	}
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CFlashManagerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CFlashManagerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CFlashManagerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFlashManagerDlg::Write4bit(u8 m)
{
	outport(m_base + 0, m);
	outport(m_base + 2, DIR_OFF | PCSTB_ON);
	while ( TRUE )
	{
		if ( m_bAbort ) return;
		if ( (inport(m_base + 1) & _GBSTB) == 0 ) break;
	}
	outport(m_base + 2, DIR_OFF | PCSTB_OFF);
}

void CFlashManagerDlg::Write32bit(u32 m)
{
	s32 i;
	for ( i = 0; i < 8; i++ )
	{
		outport(m_base + 0, (u8)(m >> (28 - 4 * i)));
		outport(m_base + 2, DIR_OFF | PCSTB_ON);
		while ( TRUE )
		{
			if ( m_bAbort ) return;
			if ( (inport(m_base + 1) & _GBSTB) == 0 ) break;	//GSTB==1
		}
		outport(m_base + 2, DIR_OFF | PCSTB_OFF);
	}
	while ( TRUE )
	{
		if ( m_bAbort ) return;
		if ( inport(m_base + 1) & _GBSTB) break;				//GSTB==0
	}
}

u8 CFlashManagerDlg::Read4bit()
{
	u8 m;
	outport(m_base + 2, DIR_ON | PCSTB_OFF);
	while ( TRUE )
	{
		if ( m_bAbort ) return 0;
		if ( (inport(m_base + 1) & _GBSTB) == 0 ) break;		//GSTB==1
	}

	m = (inport(m_base + 1) >> 3) & 0x0f;
	outport(m_base + 2, DIR_OFF | PCSTB_ON);
	while ( TRUE )
	{
		if ( m_bAbort ) return 0;
		if ( inport(m_base + 1) & _GBSTB ) break;				//GSTB==0
	}
	outport(m_base + 2, DIR_OFF | PCSTB_OFF);
	return m;
}

u32 CFlashManagerDlg::Read32bit()
{
	s32 i;
	u32 m;
	for ( i = m = 0; i < 8; i++ )
	{
		if ( m_bAbort ) return 0;
		m += Read4bit() << (4 * i);
	}
	return m;
}

BOOL CFlashManagerDlg::CRCCheck(u32 crc)
{
	while ( TRUE )
	{
		if ( m_bAbort ) return TRUE;
		if ( Read32bit() == FW_ACK ) break;
	}
	return crc == Read32bit();
}

CString CFlashManagerDlg::GetStrSize(u32 m)
{
	CString str;
	if ( m < 1024 * 1024 )
		str.Format(_T("%dKbit"), m / (1024 / 8));
	else
		str.Format(_T("%dMbit"), m / (1024 * 1024 / 8));
	return str;
}

void CFlashManagerDlg::GetCartInfoA(HWND hWnd)
{
	if ( m_bAbort ) return;
	TCHAR szWin[256];
	CString str;
	::EnableWindow(::GetDlgItem(hWnd, IDC_BTN_STOP), FALSE);
	m_nProgress = 100;
	m_bStop = FALSE;
	::GetWindowText(hWnd, szWin, 256);
#ifndef LANG_ENG
	str.Format(_T("%s - GBA JZbg͒..."), szWin);
#else
	str.Format(_T("%s - Analyzing GBA Cart..."), szWin);
#endif
	::SetWindowText(hWnd, str);
	GetCartInfo();
	::SetWindowText(hWnd, szWin);
	::EnableWindow(::GetDlgItem(hWnd, IDC_BTN_STOP), TRUE);
}

void CFlashManagerDlg::GetCartInfo()
{
	Write32bit(CMD_BU_PROBE);	//cmd is 4 dwort
	Write32bit(0);
	Write32bit(0);
	Write32bit(0);
	while ( TRUE )
	{
		if ( m_bAbort ) return;
		m_nRamType = Read32bit();	// 0:NONE 1:SRAM256K 2:SRAM512K 3:FLASH512K 4:EEPROM4K 5:EEPROM64K
		if ( m_nRamType != 0x5555AAAA ) break;
	}
	Write32bit(CMD_ROM_PROBE);	//cmd is 4 dwort
	Write32bit(0);
	Write32bit(0);
	Write32bit(0);
	while ( TRUE )
	{
		if ( m_bAbort ) return;
		m_nRomType = Read32bit();	// 0:NONE 1:MASK 2-:FLASH
		if ( m_nRomType != 0x5555AAAA ) break;
	}
	m_nRomSize = Read32bit();
	m_nRomBlkSize = Read32bit();

	if ( m_nRomType >= 2 )
	{
		Write32bit(CMD_BLANK);
		Write32bit(0);
		Write32bit(0);
		Write32bit(0);
		while ( TRUE )
		{
			if ( m_bAbort ) return;
			m_nRomUnuSize = Read32bit();
			if ( m_nRomUnuSize != 0x5555AAAA ) break;
		}
	}
	else m_nRomUnuSize = 0;

	u32 startAdr = ROM_BASE_ADR + CART_LOGO_OFST;
	u32 endAdr = m_nRomSize - m_nRomUnuSize + ROM_BASE_ADR;
	if ( m_nRamType > 0 && endAdr > startAdr)
	{
		for ( u32 i = 0; i < MAX_MULTI_GAMES; i++ )
		{
			Write32bit(CMD_FIND);
			Write32bit(startAdr);
			Write32bit(endAdr - startAdr);
			Write32bit(MAX_CART_LOGO + (0x8000 << 16));
			u32 *ptr = (u32*)m_fwlib + CART_LOGO_OFST / 4;
			for ( u32 j = 0; j < MAX_CART_LOGO / 4; j++ )
			{
				Write32bit(*ptr++);
			}
			while ( TRUE )
			{
				if ( m_bAbort ) return;
				startAdr = Read32bit();
				if ( startAdr != 0x5555AAAA ) break;
			}
			m_nStartAdr[i] = startAdr;
			m_nEndAdr[i] = endAdr;
			if ( startAdr == 0 ) break;
			m_nStartAdr[i] -= CART_LOGO_OFST;
			if ( i > 0 ) m_nEndAdr[i - 1] = startAdr - CART_LOGO_OFST - 1;

			Write32bit(CMD_READ);
			Write32bit(m_nStartAdr[i] + CART_NAME_OFST);
			Write32bit(MAX_CART_NAME + MAX_GAME_CODE);
			Write32bit(0);
			Read32bit();	// dummy
			for ( j = 0; j < MAX_CART_NAME / 4; j++ )
			{
				u32 data = Read32bit();
				m_szCartName[i][j*4 + 0] = (TCHAR)((data >>  0) & 0xFF);
				m_szCartName[i][j*4 + 1] = (TCHAR)((data >>  8) & 0xFF);
				m_szCartName[i][j*4 + 2] = (TCHAR)((data >> 16) & 0xFF);
				m_szCartName[i][j*4 + 3] = (TCHAR)((data >> 24) & 0xFF);
			}
			m_szCartName[i][MAX_CART_NAME] = '\0';
			for ( j = 0; j < MAX_GAME_CODE / 4; j++ )
			{
				u32 data = Read32bit();
				m_szGameCode[i][j*4 + 0] = (TCHAR)((data >>  0) & 0xFF);
				m_szGameCode[i][j*4 + 1] = (TCHAR)((data >>  8) & 0xFF);
				m_szGameCode[i][j*4 + 2] = (TCHAR)((data >> 16) & 0xFF);
				m_szGameCode[i][j*4 + 3] = (TCHAR)((data >> 24) & 0xFF);
			}
			m_szGameCode[i][MAX_GAME_CODE] = '\0';
			while ( Read32bit() != FW_ACK ) if ( m_bAbort ) return;
			Read32bit();	// CRC32

			startAdr += 0x8000;
			if ( startAdr > endAdr || m_nRomType < 2 )
			{
				if ( i < MAX_MULTI_GAMES - 1 )
				{
					m_nStartAdr[i + 1] = 0;
					m_nEndAdr[i + 1] = 0;
				}
				break;
			}
		}
	}
	else
	{
		m_nStartAdr[0] = 0;
		m_nEndAdr[0] = 0;
	}
}

void CFlashManagerDlg::ReadCart(u32 *buf, u32 offset, u32 len, BOOL bSram)
{
	do
	{
		if ( m_bStop || m_bAbort ) return;
		if ( bSram )
		{
			switch ( m_nRamType )
			{
			case 4 :
			case 5 :
				Write32bit(CMD_EEP_READ);
				Write32bit(offset * 4);
				Write32bit(len * 4);
				Write32bit(0);
				Sleep(400);
				break;
			default :
				if ( m_nRamType == 2 && offset / 0x2000 > 0 )
				{
					Write32bit(CMD_SRAM2EWRAM);
					Write32bit(offset / 0x2000);
					Write32bit(0);
					Write32bit(0);
					Sleep(800);
					if ( len > 0x2000 ) len = 0x2000;
					Write32bit(CMD_READ);
					Write32bit(0x02010000 + (offset & 0x1FFF) * 4);
					Write32bit(len * 4);
					Write32bit(0);
				}
				else
				{
					Write32bit(CMD_SRAM_READ);
					Write32bit(offset * 4);
					Write32bit(len * 4);
					Write32bit(0);
					Sleep(200);
				}
			}
		}
		else
		{
			Write32bit(CMD_READ);
			Write32bit(ROM_BASE_ADR + offset * 4);
			Write32bit(len * 4);
			Write32bit(0);
		}
		Read32bit();	// dummy
		for ( u32 i = 0; i < len; i++ )
		{
			if ( m_bAbort ) return;
			buf[i] = Read32bit();
		}
		crc32 = 0xFFFFFFFF;
	}
	while ( !CRCCheck(crc32_calc((u8*)buf, len * 4)) );
}

void CFlashManagerDlg::WriteCart(u32 *buf, u32 offset, u32 len, BOOL bSram, BOOL bAppend)
{
	do
	{
		if ( m_bStop || m_bAbort ) return;
		if ( bSram )
		{
			switch ( m_nRamType )
			{
			case 1 :
			case 2 :
				if ( m_nRamType == 2 && offset / 0x2000 > 0 )
				{
					if ( len < 0x2000 )
					{
						Write32bit(CMD_SRAM2EWRAM);
						Write32bit(offset / 0x2000);
						Write32bit(0);
						Write32bit(0);
						Sleep(800);
					}
					if ( len > 0x2000 ) len = 0x2000;
					Write32bit(CMD_WRITE);
					Write32bit(0x02010000 + (offset & 0x1FFF) * 4);
					Write32bit(len * 4);
					Write32bit(0);
				}
				else
				{
					Write32bit(CMD_SRAM_WRITE);
					Write32bit(offset * 4);
					Write32bit(len * 4);
					Write32bit(0);
				}
				break;
			case 3 :
				Write32bit(CMD_FLASH_WRITE);
				Write32bit(offset * 4);
				Write32bit(len * 4);
				Write32bit(0);
				break;
			case 4 :
			case 5 :
				Write32bit(CMD_EEP_WRITE);
				Write32bit(offset * 4);
				Write32bit(len * 4);
				Write32bit(0);
				break;
			}
		}
		else
		{
			if ( bAppend )	// [0040E42C]
				Write32bit(CMD_ROM_WRITE);
			else
				Write32bit(CMD_ROM_BWRITE);
			Write32bit(offset * 4);
			Write32bit(len * 4);
			Write32bit(0);
		}
		for ( u32 i = 0; i < len; i++ )
		{
			if ( m_bAbort ) return;
			Write32bit(buf[i]);
		}
		crc32 = 0xFFFFFFFF;
	}
	while ( !CRCCheck(crc32_calc((u8*)buf, len * 4)) );
	if ( bSram && m_nRamType == 2 && offset / 0x2000 > 0 )
	{
		Write32bit(CMD_EWRAM2SRAM);
		Write32bit(offset / 0x2000);
		Write32bit(0);
		Write32bit(0);
		Sleep(800);
	}
}

UINT CFlashManagerDlg::ReadRom(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeCreate | CFile::modeWrite) )
	{
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)쐬邱Ƃł܂B\n"
			"ݐ̃hCȕԂmFĂB"), m_strFileName);
#else
		str.Format(_T(
			"Can NOT create the file(%s).\n"
			"Check your drive state which you will write to."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < m_nRomSize; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / m_nRomSize;
		if ( m_nProgress != nProgress )
		{
#ifndef LANG_ENG
			str.Format(_T("%d%% %s - vOf[^ǂݍݒ... (o: %s)"), m_nProgress, szWin, m_strFileName);
#else
			str.Format(_T("%d%% %s - Reading Program Code... (Output: %s)"), m_nProgress, szWin, m_strFileName);
#endif
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		ReadCart((u32 *)m_buf, i / 4, BLOCK_SIZE / 4, FALSE);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
		file.Write(m_buf, BLOCK_SIZE);
	}
	file.Close();

THREADFINISH:
	if ( m_bStop || m_bAbort )
	{
		TRY
			CFile::Remove(m_strFileName);
		CATCH(CFileException, e)
		END_CATCH
	}
	::SetWindowText((HWND)pParam, szWin);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManagerDlg::EraseRom(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	for ( u32 i = 0; i < m_nRomSize; i += m_nRomBlkSize )
	{
		m_nProgress = i * 100 / m_nRomSize;
		if ( m_nProgress != nProgress )
		{
#ifndef LANG_ENG
			str.Format(_T("%d%% %s - vOf[^..."), m_nProgress, szWin);
#else
			str.Format(_T("%d%% %s - Erasing Program Code..."), m_nProgress, szWin);
#endif
			::SetWindowText((HWND)pParam, str);
		}
		Write32bit(CMD_ROM_BERASE);
		Write32bit(i);
		Write32bit(0);
		Write32bit(0);
		while ( Read32bit() != FW_ACK ) if ( m_bAbort ) goto THREADFINISH;
		if ( m_bStop || m_bAbort ) goto THREADFINISH;
	}
THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	GetCartInfoA((HWND)pParam);
	::PostMessage((HWND) pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManagerDlg::WritePreBoot(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeRead) )
	{
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)JƂł܂B\n"
			"ǂݍݐ̃hCȕԂmFĂB"), m_strFileName);
#else
		str.Format(_T(
			"Can NOT open the file(%s).\n"
			"Check your drive which you will read from."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	u32 len = (u32)file.GetLength();
	if ( m_nRomSize < len )
	{
		file.Close();
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)̑傫\n"
			"tbVJZbg̗eʂ𒴂Ă܂B"), m_strFileName);
#else
		str.Format(_T(
			"The file(%s) size is LARGER than\n"
			"whole capacity of Flash Cartridge."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < len; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / len;
		if ( m_nProgress != nProgress )
		{
#ifndef LANG_ENG
			str.Format(_T("%d%% %s - vOf[^擪ݒ... (: %s)"), m_nProgress, szWin, m_strFileName);
#else
			str.Format(_T("%d%% %s - Writing Program Code... (Input: %s)"), m_nProgress, szWin, m_strFileName);
#endif
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		u32 _len = file.Read(m_buf, BLOCK_SIZE);
		WriteCart((u32 *)m_buf, i / 4, (_len + 3) / 4, FALSE, FALSE);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
	}
	file.Close();
THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	GetCartInfoA((HWND)pParam);
	::PostMessage((HWND) pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManagerDlg::WriteAppendRom(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	u32 dev_ofs = m_nRomSize - (m_nRomUnuSize & 0xFFFF8000);
	if ( dev_ofs != 0 )
	{
		u32 i;
		Write32bit(CMD_IS_PRO);
		Write32bit(0);
		Write32bit(0);
		Write32bit(0);
		while ( TRUE )
		{
			if ( m_bAbort ) goto THREADFINISH;
			i = Read32bit();
			if ( i != 0x5555AAAA ) break;
		}
		if ( i == 0 )
		{	// PRO łȂ
			if ( (dev_ofs & 0xFFC08000) != dev_ofs )
			{
				dev_ofs = (dev_ofs + 0x003FFFFF) & 0xFFC00000;
			}
			dev_ofs |= 0x8000;
		}
	}
	if ( !file.Open(m_strFileName, CFile::modeRead) )
	{
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)JƂł܂B\n"
			"ǂݍݐ̃hCȕԂmFĂB"), m_strFileName);
#else
		str.Format(_T(
			"Can NOT open the file(%s).\n"
			"Check your drive which you will read from."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	u32 len = (u32)file.GetLength();
	if ( m_nRomSize - dev_ofs < len )
	{
		file.Close();
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)̑傫\n"
			"tbVJZbg̋󂫗eʂ𒴂Ă܂B"), m_strFileName);
#else
		str.Format(_T(
			"The file(%s) size is LARGER than\n"
			"free capacity of Flash Cartridge."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < len; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / len;
		if ( m_nProgress != nProgress )
		{
#ifndef LANG_ENG
			str.Format(_T("%d%% %s - vOf[^ǉݒ... (: %s)"), m_nProgress, szWin, m_strFileName);
#else
			str.Format(_T("%d%% %s - Appending Program Code... (Input: %s)"), m_nProgress, szWin, m_strFileName);
#endif
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		u32 _len = file.Read(m_buf, BLOCK_SIZE);
		WriteCart((u32 *)m_buf, (i + dev_ofs) / 4, (_len + 3) / 4, FALSE, FALSE);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
	}
	file.Close();
THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	GetCartInfoA((HWND)pParam);
	::PostMessage((HWND) pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManagerDlg::ReadRam(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeCreate | CFile::modeWrite) )
	{
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)쐬邱Ƃł܂B\n"
			"ݐ̃hCȕԂmFĂB"), m_strFileName);
#else
		str.Format(_T(
			"Can NOT create the file(%s).\n"
			"Check your drive state which you will write to."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < m_nRamSize; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / m_nRamSize;
		if ( m_nProgress != nProgress )
		{
#ifndef LANG_ENG
			str.Format(_T("%d%% %s - Z[uf[^ǂݍݒ... (o: %s)"), m_nProgress, szWin, m_strFileName);
#else
			str.Format(_T("%d%% %s - Reading Save Data... (Output: %s)"), m_nProgress, szWin, m_strFileName);
#endif
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		u32 len = m_nRamSize > BLOCK_SIZE ? BLOCK_SIZE : m_nRamSize;
		ReadCart((u32 *)m_buf, (i + m_nRamOffset) / 4, len / 4, TRUE);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
		if ( m_bConvEEPRom )
		{
			len = 0x0200;
			if ( i < len )
				SramToEEPRom(len);
			else
				break;
		}
		file.Write(m_buf, len);
	}
	file.Close();

THREADFINISH:
	if ( m_bStop || m_bAbort )
	{
		TRY
			CFile::Remove(m_strFileName);
		CATCH(CFileException, e)
		END_CATCH
	}
	::SetWindowText((HWND)pParam, szWin);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

UINT CFlashManagerDlg::WriteRam(LPVOID pParam)
{
	TCHAR szWin[256];
	CString str;
	m_nProgress = 0;
	int nProgress = -1;
	::GetWindowText((HWND)pParam, szWin, 256);
	CFile file;
	if ( !file.Open(m_strFileName, CFile::modeRead) )
	{
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)JƂł܂B\n"
			"ǂݍݐ̃hCȕԂmFĂB"), m_strFileName);
#else
		str.Format(_T(
			"Can NOT open the file(%s).\n"
			"Check your drive which you will read from."), m_strFileName);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	if ( !m_bConvEEPRom && file.GetLength() != m_nRamSize ||
		m_bConvEEPRom && file.GetLength() != 0x0200 )
	{
		file.Close();
#ifndef LANG_ENG
		str.Format(_T(
			"t@C(%s)̑傫\n"
			"GBA JZbg RAM eʂɈv܂B"), m_strFileName, m_nRamSize);
#else
		str.Format(_T(
			"The file(%s) size is\n"
			"different from RAM capacity of GBA Cartridge."), m_strFileName, m_nRamSize);
#endif
		AfxMessageBox(str);
		goto THREADFINISH;
	}
	for ( u32 i = 0; i < m_nRamSize; i += BLOCK_SIZE )
	{
		m_nProgress = i * 100 / m_nRamSize;
		if ( m_nProgress != nProgress )
		{
#ifndef LANG_ENG
			str.Format(_T("%d%% %s - Z[uf[^ݒ... (o: %s)"), m_nProgress, szWin, m_strFileName);
#else
			str.Format(_T("%d%% %s - Writing Save Data... (Output: %s)"), m_nProgress, szWin, m_strFileName);
#endif
			::SetWindowText((HWND)pParam, str);
			nProgress = m_nProgress;
		}
		u32 len = m_nRamSize > BLOCK_SIZE ? BLOCK_SIZE : m_nRamSize;
		if ( m_bConvEEPRom )
			if ( i < len )
			{
				file.Read(m_buf, 0x0200);
				EEPRomToSram(0x0200);
			}
			else
				break;
		else
			file.Read(m_buf, len);
		WriteCart((u32 *)m_buf, (i + m_nRamOffset) / 4, len / 4, TRUE, FALSE);
		if ( m_bStop || m_bAbort ) {
			file.Close();
			goto THREADFINISH;
		}
	}
	file.Close();

THREADFINISH:
	::SetWindowText((HWND)pParam, szWin);
	::PostMessage((HWND)pParam, WM_THREADFINISHED, 0, 0);
	return 0;
}

void CFlashManagerDlg::SramToEEPRom(u32 len)
{
	u16 data;
	u8 buf[BLOCK_SIZE];
	::memcpy(buf, m_buf, BLOCK_SIZE);
	::ZeroMemory(m_buf, BLOCK_SIZE);
	if ( len * 0x10 + 0x200 > BLOCK_SIZE )
		len = (BLOCK_SIZE - 0x200) / 0x10;
	for ( u32 i = 0; i < len; i += 2 )
	{
		data = 0;
		for ( u32 j = 0; j < 16; j++ )
		{
			data <<= 1;
			data |= buf[(i & 0xFFF8) * 0x10 +
				0x80 - ((i % 8) + 2) * 0x10 +
				j * 2 + 0x200] & 0x0001;
		}
		m_buf[i+1] = (u8)(data >> 8);
		m_buf[i] = (u8)data;
	}
}

void CFlashManagerDlg::EEPRomToSram(u32 len)
{
	u16 data;
	u8 buf[BLOCK_SIZE];
	::memcpy(buf, m_buf, BLOCK_SIZE);
	::ZeroMemory(m_buf, BLOCK_SIZE);
	if ( len * 0x10 + 0x200 > BLOCK_SIZE )
		len = (BLOCK_SIZE - 0x200) / 0x10;
	for ( u32 i = 0; i < len; i += 2 )
	{
		data = buf[i+1] << 8;
		data |= buf[i];
		for ( u32 j = 0; j < 16; j++ )
		{
			m_buf[(i & 0xFFF8) * 0x10 +
				0x80 - ((i % 8) + 2) * 0x10 +
				0x20 - (j + 1) * 2 + 0x200] = (u8)data;
			data >>= 1;
		}
	}
}

void CFlashManagerDlg::BtnEnable(BOOL bEnable)
{
	switch ( m_nRomType )
	{
	case 0 :
		GetDlgItem(IDC_BTN_PWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ERASE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_AREAD)->EnableWindow(FALSE);
		break;
	case 1 :
		GetDlgItem(IDC_BTN_PWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_ERASE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_AREAD)->EnableWindow(bEnable);
		break;
	default :
		GetDlgItem(IDC_BTN_PWRITE)->EnableWindow(bEnable);
		GetDlgItem(IDC_BTN_AWRITE)->EnableWindow(bEnable);
		GetDlgItem(IDC_BTN_ERASE)->EnableWindow(bEnable);
		GetDlgItem(IDC_BTN_AREAD)->EnableWindow(bEnable);
	}

	if ( m_nRamType != 0 )
	{
		GetDlgItem(IDC_BTN_SWRITE)->EnableWindow(bEnable);
		GetDlgItem(IDC_BTN_SREAD)->EnableWindow(bEnable);
	}
	else
	{
		GetDlgItem(IDC_BTN_SWRITE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_SREAD)->EnableWindow(FALSE);
	}
	if ( m_nRamType == 2 )
	{
		if ( !m_bEEPRom )
			for ( u32 i = IDC_RDO_S8; i <= IDC_RDO_S256; i++ )
				GetDlgItem(i)->EnableWindow();
		GetDlgItem(IDC_CHK_EEPROM)->EnableWindow();
		GetDlgItem(IDC_EDT_SOFS)->EnableWindow();
	}
	else
	{
		for ( u32 i = IDC_RDO_B64A; i <= IDC_RDO_S256; i++ )
			GetDlgItem(i)->EnableWindow(FALSE);
		GetDlgItem(IDC_CHK_EEPROM)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDT_SOFS)->EnableWindow(FALSE);
	}
	GetDlgItem(IDOK)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_STOP)->EnableWindow(!bEnable);
}

void CFlashManagerDlg::RefreshCartInfo()
{
	m_list_rom_ctrl.DeleteAllItems();
	for ( u32 i = 0; i < MAX_MULTI_GAMES; i++ )
	{
		if ( m_nStartAdr[i] == 0 ) break;
		m_list_rom_ctrl.InsertItem(i, m_szCartName[i]);
		m_list_rom_ctrl.SetItemText(i, 1, m_szGameCode[i]);
		m_list_rom_ctrl.SetItemText(i, 2, GetStrSize(m_nEndAdr[i] - m_nStartAdr[i] + 1));
	}
	SetDlgItemText(IDC_STC_ROMFREE, GetStrSize(m_nRomUnuSize));
}

LRESULT CFlashManagerDlg::OnThreadFinished(WPARAM wParam, LPARAM lParam)
{
	BtnEnable();
	if ( m_nTimer )
	{
		KillTimer(m_nTimer);
		m_nTimer = 0;
		m_nProgress = 0;
		((CProgressCtrl*)GetDlgItem(IDC_PROGRESS1))->SetPos(m_nProgress);
	}
	RefreshCartInfo();
	m_pThread = NULL;
	if ( m_bAbort ) OnCancel();
	return 0;
}

void CFlashManagerDlg::OnTimer(UINT nIDEvent)
{
	// TODO : ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if ( m_nTimer == nIDEvent )
		((CProgressCtrl*)GetDlgItem(IDC_PROGRESS1))->SetPos(m_nProgress);

	CDialog::OnTimer(nIDEvent);
}

BOOL CFlashManagerDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO : ɓȃR[hǉ邩A͊{NXĂяoĂB
	switch ( pMsg->message )
	{
	case WM_LBUTTONDOWN :
	case WM_LBUTTONUP :
	case WM_MOUSEMOVE :
		// }EX bZ[Wc[ qg Rg[ɓnď܂
		m_toolTipCtrl.RelayEvent( pMsg );
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CFlashManagerDlg::OnBnClickedBtnStop()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	m_bStop = TRUE;
}

void CFlashManagerDlg::OnBnClickedCancel()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if ( m_pThread )
	{
		m_pThread->SuspendThread();
#ifndef LANG_ENG
		if ( AfxMessageBox(_T("słI܂?"),
#else
		if ( AfxMessageBox(_T("Really ABORT the processing?"),
#endif
			MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDYES )
		{
			m_bAbort = TRUE;
		}
		m_pThread->ResumeThread();
	}
	else
		OnCancel();
}

#ifndef LANG_ENG
const TCHAR CFlashManagerDlg::m_szPrgFilter[] =
	_T("vOf[^(*.gba *.bin)|*.gba; *.bin|SẴt@C(*.*)|*.*||");
const TCHAR CFlashManagerDlg::m_szSavFilter[] =
	_T("Z[uf[^(*.sav *.dat)|*.sav; *.dat|SẴt@C(*.*)|*.*||");
#else
const TCHAR CFlashManagerDlg::m_szPrgFilter[] =
	_T("Program Code(*.gba *.bin)|*.gba; *.bin|All Files(*.*)|*.*||");
const TCHAR CFlashManagerDlg::m_szSavFilter[] =
	_T("Save Data(*.sav *.dat)|*.sav; *.dat|All Files(*.*)|*.*||");
#endif

void CFlashManagerDlg::OnBnClickedBtnAread()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(FALSE, _T("gba"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_szPrgFilter, this, 0 );
#ifndef LANG_ENG
	fileDlg.m_ofn.lpstrTitle = _T("vOf[^ۑt@CI");
#else
	fileDlg.m_ofn.lpstrTitle = _T("Save Program Code(ROM)");
#endif
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManagerDlg::ReadRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManagerDlg::OnBnClickedBtnErase()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
#ifndef LANG_ENG
	if ( AfxMessageBox(_T("tbVJZbgSĂ낵ł?"),
#else
	if ( AfxMessageBox(_T("Rally ERASE the whole Flash Cartridge?"),
#endif
		MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDYES )
	{
		BtnEnable(FALSE);
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManagerDlg::EraseRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManagerDlg::OnBnClickedBtnPwrite()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, m_szPrgFilter, this, 0 );
#ifndef LANG_ENG
	fileDlg.m_ofn.lpstrTitle = _T("vOf[^Jt@CI");
#else
	fileDlg.m_ofn.lpstrTitle = _T("Open Program Code(ROM)");
#endif
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManagerDlg::WritePreBoot, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManagerDlg::OnBnClickedBtnAwrite()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, m_szPrgFilter, this, 0 );
#ifndef LANG_ENG
	fileDlg.m_ofn.lpstrTitle = _T("vOf[^Jt@CI");
#else
	fileDlg.m_ofn.lpstrTitle = _T("Open Program Code(ROM)");
#endif
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManagerDlg::WriteAppendRom, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManagerDlg::OnBnClickedRdoB64a()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	UpdateData();
	m_strOffset.Format(_T("0x%08X"),
		m_nRamBank64 * 0x10000 + m_nRamBank32 * 0x08000 + m_nRamBank8 * 0x02000);
	UpdateData(FALSE);
}

void CFlashManagerDlg::OnBnClickedRdoS8()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	int i;
	UpdateData();
	if ( m_bEEPRom )
	{
		m_nRamSizeNo = 0;
		for ( i = IDC_RDO_S8; i <= IDC_RDO_S256; i++ )
			GetDlgItem(i)->EnableWindow(FALSE);
	}
	else
		for ( i = IDC_RDO_S8; i <= IDC_RDO_S256; i++ )
			GetDlgItem(i)->EnableWindow();
	for ( i = IDC_RDO_B64A; i <= IDC_RDO_B8D; i++ )
		GetDlgItem(i)->EnableWindow(FALSE);
	switch ( m_nRamSizeNo )
	{
	case 0 :
		for ( i = IDC_RDO_B64A; i <= IDC_RDO_B8D; i++ )
			GetDlgItem(i)->EnableWindow();
		break;
	case 1 :
		for ( i = IDC_RDO_B64A; i <= IDC_RDO_B32B; i++ )
			GetDlgItem(i)->EnableWindow();
		m_nRamBank8 = 0;
		break;
	case 2 :
		for ( i = IDC_RDO_B64A; i <= IDC_RDO_B64D; i++ )
			GetDlgItem(i)->EnableWindow();
		m_nRamBank8 = 0;
		m_nRamBank32 = 0;
		break;
	case 3 :
		GetDlgItem(IDC_RDO_B64A)->EnableWindow();
		GetDlgItem(IDC_RDO_B64C)->EnableWindow();
		m_nRamBank8 = 0;
		m_nRamBank32 = 0;
		m_nRamBank64 &= 0xFE;
		break;
	case 4 :
		m_nRamBank8 = 0;
		m_nRamBank32 = 0;
		m_nRamBank64 = 0;
		break;
	}
	UpdateData(FALSE);
	OnBnClickedRdoB64a();
}

void CFlashManagerDlg::SetSramType()
{
	UpdateData();
	TCHAR *tmp;
	switch ( m_nRamType )
	{
	case 1 :
		m_nRamOffset = 0x00000;
		m_nRamSize	 = 0x08000;
		break;
	case 3 :
		m_nRamOffset = 0x00000;
		m_nRamSize	 = 0x10000;
		break;
	case 4 :
		m_nRamOffset = 0x00000;
		m_nRamSize	 = 0x00200;
		break;
	case 5 :
		m_nRamOffset = 0x00000;
		m_nRamSize	 = 0x02000;
		break;
	default :
		if ( m_strOffset.Left(2) == _T("0x") )
			m_nRamOffset = _tcstoul(m_strOffset.Mid(2), &tmp, 16);
		else
			m_nRamOffset = _tcstoul(m_strOffset, &tmp, 10);
		switch ( m_nRamSizeNo )
		{
		case 0 :
			m_nRamOffset &=	0xFFFFE000;
			m_nRamSize	 =	0x00002000;
			break;
		case 1 :
			m_nRamOffset &=	0xFFFF8000;
			m_nRamSize	 =	0x00008000;
			break;
		case 2 :
			m_nRamOffset &=	0xFFFF0000;
			m_nRamSize	 =	0x00010000;
			break;
		case 3 :
			m_nRamOffset &=	0xFFFE0000;
			m_nRamSize	 =	0x00020000;
			break;
		case 4 :
			m_nRamOffset &=	0xFFFC0000;
			m_nRamSize	 =	0x00040000;
			break;
		}
	}
	m_bConvEEPRom = m_nRamType == 2 ? m_bEEPRom : FALSE;
}

void CFlashManagerDlg::OnBnClickedBtnSread()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(FALSE, _T("sav"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_szSavFilter, this, 0 );
#ifndef LANG_ENG
	fileDlg.m_ofn.lpstrTitle = _T("Z[uf[^ۑt@CI");
#else
	fileDlg.m_ofn.lpstrTitle = _T("Save Save Data(RAM)");
#endif
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		SetSramType();
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManagerDlg::ReadRam, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

void CFlashManagerDlg::OnBnClickedBtnSwrite()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, m_szSavFilter, this, 0 );
#ifndef LANG_ENG
	fileDlg.m_ofn.lpstrTitle = _T("Z[uf[^Jt@CI");
#else
	fileDlg.m_ofn.lpstrTitle = _T("Open Save Data(RAM)");
#endif
	if ( fileDlg.DoModal() == IDOK )
	{
		BtnEnable(FALSE);
		m_strFileName = fileDlg.GetPathName();
		m_bAbort = FALSE;
		m_bStop = FALSE;
		SetSramType();
		if ( m_nTimer == 0 ) m_nTimer = SetTimer(1, 100, NULL);
		m_pThread = AfxBeginThread(CFlashManagerDlg::WriteRam, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}
